image: "node"

stages:
- test
- deploy

test:
  stage: test
  script:
    - npm ci
    - npm test
  coverage: '/Statements.*?(\d=(?:\.\d+)?)%/'
  artifacts:
    paths:
      - coverage/

pages:
  stage: deploy
  dependencies: 
    - test
  script:
    - mv coverage/ public/
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - master

production:
  stage: deploy
  script:
  - npm install
  - npx gulp browserify
  - curl https://cli-assets.heroku.com/install-ubuntu.sh | sh
  - ssh-keygen -t rsa -N "" -f ~/.ssh/id_rsa
  - heroku git:remote -a idw-vue --ssh-git
  - heroku keys:add --yes
  - eval "$(ssh-agent -s)"
  - ssh-add ~/.ssh/id_rsa
  - ssh-keyscan -t rsa heroku.com >> ~/.ssh/known_hosts
  - git push heroku HEAD:master
  only:
    refs:
    - master